//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
// Copyright (c) Lawrence Livermore National Security, LLC and other Ascent
// Project developers. See top-level LICENSE AND COPYRIGHT files for dates and
// other details. No copyright assignment is required to contribute to Ascent.
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//


//-----------------------------------------------------------------------------
///
/// file: ascent_config.h
///
//-----------------------------------------------------------------------------

#ifndef ASCENT_CONFIG_H
#define ASCENT_CONFIG_H

#define ASCENT_INSTALL_PREFIX "/usr/local"

#define ASCENT_VERSION "0.9.3"

/* #undef ASCENT_GIT_SHA1 */
/* #undef ASCENT_GIT_SHA1_ABBREV */
/* #undef ASCENT_GIT_TAG */

#define ASCENT_SYSTEM_TYPE "FreeBSD-13.4-RELEASE-p4"

#define ASCENT_CPP_COMPILER "/usr/bin/c++"

#define ASCENT_FORTRAN_ENABLED   "1"
#define ASCENT_FORTRAN_COMPILER  "/usr/local/bin/gfortran13"

/* #undef ASCENT_PYTHON_ENABLED */
/* #undef ASCENT_PYTHON_EXECUTABLE */

/* #undef ASCENT_LOGGING_ENABLED */
/* #undef ASCENT_CALIPER_ENABLED */

// this path points to the web client js code tree
#define ASCENT_SOURCE_WEB_CLIENT_ROOT  "/wrkdirs/usr/ports/science/ascent/work/ascent-0.9.3/src/libs/ascent/web_clients"

// defs for general openmp/cuda support
/* #undef ASCENT_OPENMP_ENABLED */
/* #undef ASCENT_CUDA_ENABLED */
/* #undef ASCENT_HIP_ENABLED */

// defs for builtin libs
/* #undef ASCENT_VTKH_ENABLED */
/* #undef ASCENT_DRAY_ENABLED */
/* #undef ASCENT_APCOMP_ENABLED */

// defs for runtime support based on which 3rd-party libs we have
/* #undef ASCENT_CAMP_ENABLED */
/* #undef ASCENT_UMPIRE_ENABLED */
/* #undef ASCENT_RAJA_ENABLED */

/* #undef ASCENT_VTKM_ENABLED */

/* #undef ASCENT_VTKM_OPENMP_ENABLED */
/* #undef ASCENT_VTKM_CUDA_ENABLED */
/* #undef ASCENT_VTKM_KOKKOS_ENABLED */

/* #undef ASCENT_ADIOS2_ENABLED */
/* #undef ASCENT_FIDES_ENABLED */
/* #undef ASCENT_MFEM_ENABLED */

#define ASCENT_HDF5_ENABLED      "TRUE"
/* #undef ASCENT_JIT_ENABLED */
#define ASCENT_WEBSERVER_ENABLED "TRUE"
/* #undef ASCENT_GENTEN_ENABLED */
/* #undef ASCENT_KOKKOS_ENABLED */
/* #undef ASCENT_BABELFLOW_ENABLED */


#if defined(ASCENT_CUDA_ENABLED) || defined(ASCENT_HIP_ENABLED)
#define ASCENT_DEVICE_ENABLED
#endif

//-----------------------------------------------------------------------------
//
// #define platform check helpers
//
//-----------------------------------------------------------------------------

#if defined(WIN32) || defined(_WIN32) || defined(__WIN32) && !defined(__CYGWIN__)

#define ASCENT_PLATFORM_WINDOWS
#elif  defined(__APPLE__)
#define ASCENT_PLATFORM_APPLE
#else
#define ASCENT_PLATFORM_UNIX
#endif


#endif
