//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
// Copyright (c) Lawrence Livermore National Security, LLC and other Ascent
// Project developers. See top-level LICENSE AND COPYRIGHT files for dates and
// other details. No copyright assignment is required to contribute to Ascent.
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//

//-----------------------------------------------------------------------------
///
/// file: ascent_resources.hpp
///
//-----------------------------------------------------------------------------
#ifndef ASCENT_RESOURCES_HPP
#define ASCENT_RESOURCES_HPP

#include <ascent_exports.h>
#include <string>
#include <conduit.hpp>

//-----------------------------------------------------------------------------
// -- begin ascent:: --
//-----------------------------------------------------------------------------
namespace ascent
{

//-----------------------------------------------------------------------------
// -- begin ascent::resources:: --
//-----------------------------------------------------------------------------
namespace resources
{

void ASCENT_API load_compiled_resource_tree(const std::string &resource_name,
                                            conduit::Node &res);

void ASCENT_API expand_resource_tree_to_file_system(const conduit::Node &resource_tree,
                                                    const std::string &path);

//-----------------------------------------------------------------------------
};
//-----------------------------------------------------------------------------
// -- end ascent::resources:: --
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
};
//-----------------------------------------------------------------------------
// -- end ascent:: --
//-----------------------------------------------------------------------------

#endif
//-----------------------------------------------------------------------------
// -- end header ifdef guard
//-----------------------------------------------------------------------------


